/* MAX-Shell v1.0 - The M.E.C.C.A. / Batch Interface System
   
   PROGRAM: MAXSHELL.EXE

   PURPOSE: To provide a means of passing parameters to batch files
	    from within a Maximus BBS MECCA Script.
								
     USAGE: MAXSHELL [num elements] [mecca_questionnaire_file] [batch_file]

    AUTHOR: Scott Burkett, Cairo Research Labs, 1992
*/

/*------------------=[ Global Variables ]=----------------------*/

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

char parms[11][12];		/* Define Array for Passed Parameters */
char command_call[80];		/* String to hold entire Batch Call   */
int  num_elements;		/* Number of Parms for Batch Call     */	
int  cntr;			/* Generic Counter Variable	      */
int  x;				/* Generic Counter Variable	      */

void DispArgs(void);

int main(int argc, char *argv[]) 
{                	
  FILE *script;			/* File Stream for MECCA script file  */
  
  ParseCmdLine(argc, argv);     /* Parse the DOS Command Line */
		
  if ((script = fopen(argv[2], "rt")) == NULL) {
     printf("Error opening your MECCA Questionnaire File for reading\n");
     exit(1);
  }							
  
  do {
    fscanf(script, "%s", parms[cntr]);
    cntr++;
  } while (!feof(script));

  fclose(script);


  cntr--;					/* Allow for EOF Marker */

  /* Build Command Call Variable */
  strcpy(command_call, argv[3]);		/* Insert Batch File Name */
  
  for(x=0; x<=(cntr-1); x++) {
    strcat(command_call, " ");			/* Insert WhiteSpace  */
    strcat(command_call, parms[x]);		/* Insert Batch Parms */
  }

  /* Execute Batch File with New Parameters */
					
  if((x=system(command_call)) == -1) {
    textcolor(LIGHTRED);
    cprintf("FATAL ERROR: Unable to execute User's Request\n\r");
    exit(1);
  }
  return(0);
		 
}    


int ParseCmdLine(int ac, char *av[])
{						
   int i, j;
   char	*p;

   textcolor(GREEN);	
   clrscr();
   cprintf("MAXshell v1.0 - (C)1991 Cairo Research Labs\n\r");
   cprintf("MECCA/Batch Interface System for Maximus BBS v2.x \n\r");

   if(ac!=4) DispArgs();

   /* Validate num_element Integer */
				
   num_elements = atoi(av[1]);
   if((num_elements <= 0) || (num_elements >= 10)) {
     textcolor(LIGHTRED);
     cprintf("[num_elements] MUST be between 1 and 10\n\r");
     exit(1);						
   }						

   return;
}  /* ParseCmdLine() */
							
void DispArgs(void) 
{
 textcolor(WHITE);
 cprintf("\n\rUSAGE: MAXshell [num_elements] [MECCA_file] [batch_file]\n\r\n\r");					

 exit(1);
}
